Package uk.ac.starlink.table.join

# Class EllipseCartesianMatchEngine

java.lang.Object
uk.ac.starlink.table.join.AbstractCartesianMatchEngine
uk.ac.starlink.table.join.EllipseCartesianMatchEngine

All Implemented Interfaces:
  `MatchEngine`

Direct Known Subclasses:
  `EllipseCartesianMatchEngine.InDegrees`

public class EllipseCartesianMatchEngine extends AbstractCartesianMatchEngine
MatchEngine implementation for plane elliptical figures. A match is detected if the ellipses touch or overlap. Tuples are 5-element: (X,Y,A,B,theta), where (X,Y) is the centre position, A and B are the semi-major and semi-minor radii, and theta is the orientation angle in radians, being the angle from the X axis to the semi-major radius measured towards the Y axis.

The calculations are currently done using numerical optimisation.

Since:
  30 Aug 2011
Author:
  Mark Taylor

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`EllipseCartesianMatchEngine.InDegrees`
MatchEngine class that behaves like EllipseCartesianSkyMatchEngine but uses human-friendly units (degrees and arcseconds) rather than radians for tuple elements and match parameters.

## Constructor Summary

Constructors
Constructor
Description
`EllipseCartesianMatchEngine(double scale)`
Constructor.

## Method Summary

Modifier and Type
Method
Description
`Supplier<Coverage>`
`createCoverageFactory()`
Returns a supplier for coverage objects.
`Supplier<MatchKit>`
`createMatchKitFactory()`
Returns a factory for MatchKit instances corresponding to the current settings of this object.
`uk.ac.starlink.table.DescribedValue[]`
`getMatchParameters()`
Returns a set of DescribedValue objects whose values can be modified to modify the matching criteria.
`uk.ac.starlink.table.ValueInfo`
`getMatchScoreInfo()`
Returns a description of the value returned by the `MatchKit.matchScore(java.lang.Object[], java.lang.Object[])` method.
`double`
`getScale()`
Returns distance scale.
`double`
`getScoreScale()`
Returns a scale value for the match score.
`uk.ac.starlink.table.ValueInfo[]`
`getTupleInfos()`
Returns a set of ValueInfo objects indicating what is required for the elements of each tuple.
`void`
`setRecogniseCircles(boolean recogniseCircles)`
Determines whether short cuts should be taken in the calculations when the ellipses are actually circles.
`void`
`setScale(double scale)`
Sets the rough average of per-object error distance.
`String`
`toString()`

### Methods inherited from class uk.ac.starlink.table.join.AbstractCartesianMatchEngine

`getBinFactor, getIsotropicScale, getNdim, getScale, getTuningParameters, setBinFactor, setIsotropicScale, setScale`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### EllipseCartesianMatchEngine

public EllipseCartesianMatchEngine(double scale)
Constructor.

Parameters:
  `scale` - rough scale of ellipse dimensions

## Method Details

### setScale

public void setScale(double scale)
Sets the rough average of per-object error distance. This is just used in conjunction with the bin factor for tuning.

Parameters:
  `scale` - characteristic scale of errors

### getScale

public double getScale()
Returns distance scale.

Returns:
  characteristic scale of errors

### setRecogniseCircles

public void setRecogniseCircles(boolean recogniseCircles)
Determines whether short cuts should be taken in the calculations when the ellipses are actually circles. This is generally a good idea, since it is faster and improves accuracy; the default is therefore true. But you might want to turn it off for purposes of debugging or testing.

Parameters:
  `recogniseCircles` - whether to take circle-specific short cuts

### getTupleInfos

public uk.ac.starlink.table.ValueInfo[] getTupleInfos()
Description copied from interface: `MatchEngine`
Returns a set of ValueInfo objects indicating what is required for the elements of each tuple. The length of this array is the number of elements in the tuple. Each element should at least have a defined name and content class. The info's `nullable` attribute has a special meaning: if true it means that it makes sense for this element of the tuple to be always blank (for instance assigned to no column).

Returns:
  array of objects describing the requirements on each element of the tuples used for matching

### getMatchParameters

public uk.ac.starlink.table.DescribedValue[] getMatchParameters()
Description copied from interface: `MatchEngine`
Returns a set of DescribedValue objects whose values can be modified to modify the matching criteria. Typically at least one of these will be some sort of tolerance separation which determines how close tuples must be to count as a match. This match engine's behaviour can be modified by calling `DescribedValue.setValue(java.lang.Object)` on the returned objects.

Returns:
  array of described values which influence the match

### getMatchScoreInfo

public uk.ac.starlink.table.ValueInfo getMatchScoreInfo()
Description copied from interface: `MatchEngine`
Returns a description of the value returned by the `MatchKit.matchScore(java.lang.Object[], java.lang.Object[])` method. The content class should be numeric (though need not be `Double`), and the name, description and units should be descriptive of whatever the physical significance of the value is. If the result of `matchScore` is not interesting (for instance, if it's always either 0 or -1), `null` may be returned.

Returns:
  metadata for the match score results

### getScoreScale

public double getScoreScale()
Description copied from interface: `MatchEngine`
Returns a scale value for the match score. The intention is that the result of `matchScore`/`MatchEngine.getScoreScale()` is of order unity, and is thus comparable between different match engines.

As a general rule, the result should be the maximum value ever returned from the `matchScore` method, corresponding to the least good successful match. For binary MatchEngine implementations (all matches are either score=0 or failures) a value of 1 is recommended. If nothing reliable can be said about the scale, NaN may be returned.

Returns:
  scale of successful match scores, a positive finite number or NaN

### toString

public String toString()

Specified by:
  `toString` in class `AbstractCartesianMatchEngine`

### createMatchKitFactory

public Supplier<MatchKit> createMatchKitFactory()
Description copied from interface: `MatchEngine`
Returns a factory for MatchKit instances corresponding to the current settings of this object.

The returned value is immutable, and is not affected by subsequent changes of the settings of this object.

Returns:
  match kit supplier

### createCoverageFactory

public Supplier<Coverage> createCoverageFactory()
Description copied from interface: `MatchEngine`
Returns a supplier for coverage objects. Each such coverage can be used to characterise a region of tuple space. When populated with a set of tuples A, any tuple for which the inclusion function defined by its `Coverage.createTestFactory()` method returns false is guaranteed not to match any tuple in A according to this object's match criteria.

The returned value is immutable, and is not affected by subsequent changes of the settings of this object.

If no suitable implementation is available, null may be returned.

Returns:
  supplier of coverage objects, or null